"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("@uirouter/react");
const react_2 = __importStar(require("react"));
exports.default = (params = (router, 
// eslint-disable-next-line unicorn/prevent-abbreviations
ownProps
// eslint-disable-next-line @typescript-eslint/no-explicit-any
) => {
    return {
        ...ownProps,
        router
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
    };
}, update = false) => {
    return (WrappedComponent) => {
        const connectWithRouter = (
        // eslint-disable-next-line @typescript-eslint/no-explicit-any,unicorn/prevent-abbreviations
        props) => {
            // eslint-disable-next-line unicorn/prevent-abbreviations
            const ref = react_2.useRef({
                // eslint-disable-next-line react/no-multi-comp
                consumeRouter: (router) => {
                    if (!ref.current.partialProps) {
                        // eslint-disable-next-line unicorn/prevent-abbreviations
                        ref.current.partialProps = params(router, props);
                    }
                    else if (update === true) {
                        // eslint-disable-next-line unicorn/prevent-abbreviations
                        ref.current.partialProps = params(router, props);
                    }
                    else if (update) {
                        // eslint-disable-next-line unicorn/prevent-abbreviations
                        ref.current.partialProps = {
                            ...ref.current.partialProps,
                            ...update(params(router, props))
                        };
                    }
                    return (react_2.default.createElement(WrappedComponent, Object.assign({}, ref.current.partialProps, props)));
                },
                // eslint-disable-next-line unicorn/prevent-abbreviations
                partialProps: undefined
            });
            return (react_2.default.createElement(react_1.UIRouterConsumer, null, ref.current.consumeRouter));
        };
        return connectWithRouter;
    };
};
//# sourceMappingURL=index.js.map